#
# $Id: nan_subdirs.mk,v 1.2 2002/10/13 15:57:01 hans Exp $
#
# ***** BEGIN GPL/BL DUAL LICENSE BLOCK *****
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version. The Blender
# Foundation also sells licenses for use in proprietary software under
# the Blender License.  See http://www.blender.org/BL/ for information
# about this.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# The Original Code is Copyright (C) 2001-2002 by NaN Holding BV.
# All rights reserved.
#
# The Original Code is: all of this file.
#
# Contributor(s): none yet.
#
# ***** END GPL/BL DUAL LICENSE BLOCK *****
#
# Bounce make to subdirectories.
# Set DIRS, SOURCEDIR. Optionally also reacts on DIR, TESTDIRS.
#

default: all

# do not add install here. install target can only be used in intern/
# top level Makefiles
all debug clean::
    ifdef DIR
	@# Make sure object toplevels are there
	@[ -d $(NAN_OBJDIR) ] || mkdir $(NAN_OBJDIR)
	@[ -d $(LCGDIR) ] || mkdir $(LCGDIR)
	@[ -d $(OCGDIR) ] || mkdir $(OCGDIR)
	@[ -d $(OCGDIR)/intern ] || mkdir $(OCGDIR)/intern
	@[ -d $(OCGDIR)/extern ] || mkdir $(OCGDIR)/extern
	@# Create object directory
	@[ -d $(DIR) ] || mkdir $(DIR)
    endif
	@for i in $(DIRS); do \
	    echo "====> $(MAKE) $@ in $(SOURCEDIR)/$$i" ;\
	    $(MAKE) -C $$i $@ || exit 1; \
	done

test::
    ifdef TESTDIRS
	@for i in $(TESTDIRS); do \
	    echo "====> $(MAKE) $@ in $(SOURCEDIR)/$$i" ;\
	    $(MAKE) -C $$i $@ || exit 1; \
	done
    endif

